define(["dojo/_base/declare", "./UTIL"],
		function(declare, BisUtil){
	 
	var bisUtil = new BisUtil();
	
	return declare("esri.update.api.BISPROVIDER",null,{
		
		implementor:null,
		
		constructor:function(implementor){
			this.implementor = implementor;
			this.logPath= "esri.update.api.BISPROVIDER";
		},
		
		getContentAsTree: function (bisEventHandler, treeId, params){
			var handler = bisUtil.connectBisEventHandler(bisEventHandler, this.logPath + ".getContentAsTree");	
			this.implementor.getContentAsTree(handler, treeId, params);
		},
		
		search4EMReports: function (bisEventHandler, /*array*/ items) {
			var handler = bisUtil.connectBisEventHandler(bisEventHandler, this.logPath + ".search4EMReports");	
			this.implementor.search4EMReports(handler, items);
		},
		
		upgradeEMReport: function (bisEventHandler, item) {
			var handler = bisUtil.connectBisEventHandler(bisEventHandler, this.logPath + ".upgradeEMReport");	
			this.implementor.upgradeEMReport(handler, item);
		},
		
		replaceMapServiceURL: function (bisEventHandler, item, params) {
			var handler = bisUtil.connectBisEventHandler(bisEventHandler, this.logPath + ".replaceMapServiceURL");	
			this.implementor.replaceMapServiceURL(handler, item, params);
		},
		
		getProviderId: function () {
			return this.implementor.getProviderId();
		}
	});
});